(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

BeginPackage["Fluids`EOSCG`"]
Off[General::spell1]; 
Off[General::spell]; 
EOSCGSpecies::usage = "The following species are available: N2O, NO, H2S, SO2, COS, CO, PH3, HCN, CCl2O \
(phosgene), CH4O (methanol), C2H6O (ethanol), C3H8O (n-propanol), C3H8O (2-propanol), C4H10O (n-butanol), \
C4H10O (2-butanol), C4H10O (2-methyl-1-propanol), C4H10O (2-methyl-2-propanol), C6H6O (phenol), C3H6O \
(acetone), C4H8O (2-butaone), C5H10O (2-pentanone), C5H10O (3-pentanone), C5H10O (3-methyl-2-butanone), CH2O \
(formaldehyde), C2H4O (aceteldehyde), C3H6O (propionaldehyde), C2H4O2 (acetic acid), C2H4O2 (methyl Formate), \
C3H6O2 (ethyl formate), C4H8O2 (n-propyl formate), C3H6O2 (Mmethyl acetate), C4H8O2 (ethyl acetate), C2H6O \
(dimethyl ether), C3H8O (methyl ethyl ether), C4H10O (diethyl ether), C2H4O (ethylene ether), C4H8O \
(tetrahydrofuran), CH5N (methylamine), C2H7N (dimethylainine), C3H9N (trimethylamine), C2H7N (ethylamine), \
C4H11N (diethylamine), C6H15N (trimetylamine), CH3NO2 (nitromethane), C2H3N (acetonitrile), C3H3N \
(acrylonitrile), C5H5N (pyridine), CH4S (methyl mercaptan), C2H6S (dimethyl sulphide), C2H6S (ethyl \
mercaptan), CH3F (fluoromethane), CH2F2 (difluoromethane), CHF3 (trifluoromethane), C2H5F (fluoroethane), \
C2H4F2 (1,1-difluoroethane), C2H3F3 (1,1,1-trifluoroethane), CH3CI (chloromethane), CHCI3 (trichloromethane), \
C2H4Cl2 (l,l-dicliloroethane), C6H5CI (chlorobenzene), C2H5Br (bromoethane), HBr, HF, NO2, HCl, HI, C3H6 \
(propene), C4H8 (Isobutene), SiClF3, SiCl2F2, SiCl3F, He, Ne, Ar, Kr, Xe, F2, Br2, I2, Cl2, O2, S, N2, H2, \
CS2, CH4, C2H6 (ethane), C3H8 (propane), C2H4 (ethylene), C4H10 (butane), BF3, BCl3, SiF4, SiH4, SiCl4, H2O, \
CO2, NH3"
FEOSCG::usage = "FEOSCG[p,t,sp,x, options] calculates the normalized fugacities for the stable phase ( (f at \
p) / (0.1 MPa) ) according to Churakov & Gottschalk (2003) using the pressure p[MPa],the temperature t[K], sp \
the list of species names as strings and x the list of their mole fractions. For fluid mixtures the function \
returns a list of fugacities in the same order as x. This list does not include the configurational term but \
only ( (f at p) / (0.1 MPa) ). To get the complete term, the result of  FEOSCG must be multiplied by x. \
Optional parameters are Speed (either -> slow (internal Mathematica) or -> fast (external Fortran routine \
which is only available for MacOS X) and NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, \
{name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, ...} for external species (default NewSpecies -> {})."
AEOSCG::usage = "AEOSCG[\[Rho],t,sp,x, options] calculates the molar Helmholtz free energy according to Churakov \
& Gottschalk (2003) using the molar density \[Rho][MPa*mol/J],the temperature t[K], sp the list of species names \
as strings and x the list of their mole fractions. AEOSCG returns a list containing the Helmoltz free energy \
values {Aideal, Aresidual and Aideal + Aresidual} [J/mol], respectively. AEOSCG does not include the \
temperature dependent term involving the heat capacities of the fluid at standard conditions ( (A at t and (R \
t)/(0.1 MPa) - (A at 273.15 and (R 273.15)/(0.1 MPa), ideal gas). Optional parameters are Speed (either -> \
slow (internal Mathematica) or -> fast (external Fortran routine which is only available for MacOS X) and \
NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, {name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, \
...} for external species (default NewSpecies -> {})."
GEOSCG::usage = "GEOSCG[p,t,sp,x, options] calculates the molar Gibbs free energy according to Churakov & \
Gottschalk (2003) using the pressure p[MPa],the temperature t[K], sp the list of species names of species as \
strings and x the list of their mole fractions. GEOSCG returns a list of two elements containing the molar \
density [MPa*mol/J] and its Gibbs free energy [J/mol] for the liquid and the vapor phase, respectively. The \
first element contains the results for the stable phase, the second the result for a possible metastable \
phase. A result of {0,0} in the second element signals a single solution for the molar density and therefore \
supercritical conditions. GEOSCG does not include the temperature dependent term involving the heat capacities \
of the fluid at standard conditions ( (G at t and 0.1 MPa) - (G at 273.15 and 0.1 MPa), ideal gas). Optional \
parameters are Speed (either -> slow (internal Mathematica) or -> fast (external Fortran routine which is only \
available for MacOS X) and NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, \
{name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, ...} for external species (default NewSpecies -> {})."
\[Rho]EOSCG::usage = "\[Rho]EOSCG[p,t,sp,x, options] calculates the molar densities according to Churakov & \
Gottschalk (2003) using the pressure p[MPa],the temperature t[K], sp the list of species names as strings and \
x the list of their mole fractions. \[Rho]EOSCG returns a list of two elements containing the molar densities \
[MPa*mol/J] for liquid and vapor phase, respectively. The first element contains the results for the stable \
phase, the second the result for a possible metastable phase. A result of 0 in the second element signals a \
single solution for the molar density and therefore supercritical conditions. Optional parameters are Speed \
(either -> slow (internal Mathematica) or -> fast (external Fortran routine which is only available for MacOS \
X) and NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, \
{name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, ...} for external species (default NewSpecies -> {})."
VEOSCG::usage = "VEOSCG[p,t,sp,x, options] calculates the molar volumes according to Churakov & Gottschalk \
(2003) using the pressure p[MPa],the temperature t[K], sp the list of species names as strings and x the list \
of their mole fractions. VEOSCG returns a list of two elements containing the molar volume [J/MPa/mol] for \
liquid and vapor phase, respectively. The first element contains the results for the stable phase, the second \
the result for a possible metastable phase. A result of 0 in the second element signals a single solution for \
the molar volume and therefore supercritical conditions. Optional parameters are Speed (either -> slow \
(internal Mathematica) or -> fast (external Fortran routine which is only available for MacOS X) and \
NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, {name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, \
...} for external species (default NewSpecies -> {})."
miscgap::usage = "miscgap[p,t,species,increments, options] calculates the compositions of the coexisting \
phases (liquid and gas) with an InterpolatingFunction using the pressure p[MPa],the temperature t[K], sp the \
list of species names as strings and the number of increments (optional, default 25). Optional parameters are \
Speed (either -> slow (internal Mathematica) or -> fast (external Fortran routine which is only available for \
MacOS X) and NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, \
{name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, ...} for external species (default NewSpecies -> {})."
miscgapNewton::usage = "miscgapNewton[p,t,species,increments,xl,xg, options] calculates the compositions of \
the coexisting phases (liquid and gas) with the Newton method using the pressure p[MPa],the temperature t[K], \
sp the list of species names as strings, xl the starting composition of the liquid (optional, default .9999) \
and xg the starting composition of the gas (optional, default .0001). Optional parameters are Speed (either -> \
slow (internal Mathematica) or -> fast (external Fortran routine which is only available for MacOS X) and \
NewSpecies -> {{name1,\[Epsilon]1,\[Sigma]1,\[Mu]1,\[Alpha]1,molecularweight1}, {name2,\[Epsilon]2,\[Sigma]2,\[Mu]2,\[Alpha]2,molecularweight2}, \
...} for external species (default NewSpecies -> {})."
AEOSCGpara::usage = "AEOSCGpara[\[Rho],t,pa, options] calculates the molar Helmholtz free energy according to \
Churakov & Gottschalk (2003) using the density \[Rho] [J*mol/MPa],the temperature t[K]  and pa the list of the \
required parameters {\[Epsilon]/k,\[Sigma],\[Mu],\[Alpha]}. Units as listet in the tables of the paper. Optional parameters are \
Speed (either -> slow (internal Mathematica) or -> fast (external Fortran routine which is only available for \
MacOS X)."
GEOSCGpara::usage = "GEOSCGpara[p,t,pa, options] calculates the molar Gibbs free energy according to Churakov \
& Gottschalk (2003) using the pressure p [MPa],the temperature t[K]  and pa the list of the required \
parameters {\[Epsilon]/k,\[Sigma],\[Mu],\[Alpha]}. Units as listet in the tables of the paper. Optional parameters are Speed \
(either -> slow (internal Mathematica) or -> fast (external Fortran routine which is only available for MacOS \
X)."
AEOSCGfast::usage = ""
If[$OperatingSystem == "MacOSX", link = Install["Fluids/aeos", LinkMode -> Launch, LinkProtocol->"Pipes"]; defaultmodus = "fast", 
   defaultmodus = "slow"]; 
Options[FEOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[AEOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[GEOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[\[Rho]EOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[VEOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[AEOSCGpara] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[GEOSCGpara] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[PEOSCG] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[miscgap] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[miscgapNewton] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Options[flist] = {Speed -> defaultmodus, NewSpecies -> {}}; 
Begin["`Private`"]
na = 6.02214199*10^23; k = 1.3806503/10^23; r = na*k; h = 6.6261/10^34; 
  parameter = {{"N2O", 235.7, 3.658, 0.161, 0, 44.01288}, {"NO", 137, 3.094, 0.159, 0, 30.00614}, 
    {"H2S", 277.2, 3.68, 0.97, 0, 34.08188}, {"SO2", 302.7, 3.903, 1.633, 0, 64.0648}, 
    {"COS", 286.9, 4.099, 0.715, 0, 60.0761}, {"CO", 101.2, 3.623, 0.11, 0, 28.0101}, 
    {"PH3", 302.7, 3.903, 0.55, 0, 33.997581}, {"HCN", 149.7, 3.796, 2.984, 0, 27.02538}, 
    {"CCl2O (phosgene)", 342.3, 4.548, 1.17, 0, 98.9155}, {"CH4O (methanol)", 359, 3.803, 0.71, 0, 32.04186}, 
    {"C2H6O (ethanol)", 373.3, 4.299, 0.73, 0, 46.06844}, {"C3H8O (n-propanol)", 398.1, 4.691, 0.69, 0, 
     60.09502}, {"C3H8O (2-propanol)", 376.8, 4.699, 0.66, 0, 60.09502}, 
    {"C4H10O (n-butanol)", 421.8, 5.047, 0.66, 0, 74.1216}, {"C4H10O (2-butanol)", 401.1, 5.037, 0.66, 0, 
     74.1216}, {"C4H10O (2-methyl-1-propanol)", 410.4, 5.041, 0.64, 0, 74.1216}, 
    {"C4H10O (2-methyl-2-propanol)", 378.1, 5.061, 0.67, 0, 74.1216}, {"C6H6O (phenol)", 524.9, 5079, 1.45, 0, 
     94.11124}, {"C3H6O (acetone)", 326.2, 4.691, 2.88, 0, 58.07914}, {"C4H8O (2-butaone)", 370.4, 5.036, 2.8, 
     0, 72.10572}, {"C5H10O (2-pentanone)", 402.5, 5.38, 2.72, 0, 86.1323}, 
    {"C5H10O (3-pentanone)", 401.9, 5.345, 2.72, 0, 86.1323}, {"C5H10O (3-methyl-2-butanone)", 393.9, 5.338, 
     2.77, 0, 86.1323}, {"CH2O (formaldehyde)", 206.5, 3.731, 2.33, 0, 30.02598}, 
    {"C2H4O (aceteldehyde)", 268.3, 4.248, 2.69, 0, 44.05256}, {"C3H6O (propionaldehyde)", 335.5, 4.648, 2.52, 
     0, 58.07914}, {"C2H4O2 (acetic acid)", 435.6, 4.356, 1.74, 0, 60.0519}, 
    {"C2H4O2 (methyl Formate)", 352.6, 4.374, 1.77, 0, 60.05196}, {"C3H6O2 (ethyl formate)", 371.9, 4.806, 
     0.94, 0, 74.07854}, {"C4H8O2 (n-propyl formate)", 402.9, 5.159, 0.7, 0, 88.10512}, 
    {"C3H6O2 (methyl acetate)", 376.3, 4.781, 0.67, 0, 74.07854}, {"C4H8O2 (ethyl acetate)", 390.3, 5.153, 
     0.78, 0, 88.10512}, {"C2H6O (dimethyl ether)", 297.1, 4.386, 0.3, 0, 46.06844}, 
    {"C3H8O (methyl ethyl ether)", 329.5, 4.793, 0.23, 0, 60.09502}, {"C4H10O (diethyl ether)", 353.4, 5.166, 
     0.13, 0, 74.1216}, {"C2H4O (ethylene ether)", 324.7, 4.079, 1.89, 0, 44.05256}, 
    {"C4H8O (tetrahydrofuran)", 403.4, 4.856, 1.63, 0, 72.10572}, {"CH5N (methylamine)", 315.1, 3.91, 1.29, 0, 
     31.05714}, {"C2H7N (dimethylainine)", 329.8, 4.444, 1.03, 0, 45.08372}, 
    {"C3H9N (trimethylamine)", 329.4, 4.918, 0.63, 0, 59.1103}, {"C2H7N (ethylamine)", 342.1, 4.431, 1.22, 0, 
     45.08372}, {"C4H11N (diethylamine)", 377.2, 5.212, 0.91, 0, 73.13688}, 
    {"C6H15N (trimetylamine)", 407, 5.798, 0.83, 0, 101.19004}, {"CH3NO2 (nitromethane)", 290.4, 4.347, 3.57, 
     0, 61.04006}, {"C2H3N (acetonitrile)", 175.7, 4.284, 3.92, 0, 41.05196}, 
    {"C3H3N (acrylonitrile)", 244.3, 4606, 3.87, 0, 53.06266}, {"C5H5N (pyridine)", 453.3, 4.956, 2.25, 0, 
     79.09994}, {"CH4S (methyl mercaptan)", 343.7, 4.19, 1.52, 0, 48.10846}, 
    {"C2H6S (dimethyl sulphide)", 375.1, 4.637, 1.5, 0, 62.13504}, {"C2H6S (ethyl mercaptan)", 371.2, 4.659, 
     1.56, 0, 62.13504}, {"CH3F (fluoromethane)", 186.7, 3.766, 1.82, 0, 34.0329232}, 
    {"CH2F2 (difluoromethane)", 213, 3.881, 1.96, 0, 52.0233864}, {"CHF3 (trifluoromethane)", 199.6, 4.007, 
     1.62, 0, 70.0138496}, {"C2H5F (fluoroethane)", 253.3, 4.268, 1.94, 0, 48.0595032}, 
    {"C2H4F2 (1,1-difluoroethane)", 248.5, 4.429, 2.3, 0, 66.0499664}, {"C2H3F3 (1,1,1-trifluoroethane)", 
     221.2, 4.535, 2.28, 0, 84.0404296}, {"CH3Cl (chloromethane)", 279.8, 4.097, 1.94, 0, 50.48722}, 
    {"CHCl3 (trichloromethane)", 406.5, 4.829, 1.05, 0, 119.37674}, {"C2H4Cl2 (l,l-dicliloroethane)", 381.7, 
     4.9, 2.06, 0, 98.95856}, {"C6H5Cl (chlorobenzene)", 476.3, 5.319, 1.69, 0, 112.5566}, 
    {"C2H5Br (bromoethane)", 370.2, 4.684, 1.79, 0, 108.9651}, {"HBr", 272.4, 3.705, 0.827, 0, 80.91194}, 
    {"HF", 237, 3.058, 1.826, 0, 20.0063432}, {"NO2", 328.1, 3.431, 0.316, 0, 46.00554}, 
    {"HCl", 230.9, 3.455, 1.109, 0, 36.46064}, {"HI", 322.5, 4.05, 0.448, 0, 127.91241}, 
    {"C3H6 (propene)", 277.7, 4.49, 0.366, 0, 42.07974}, {"C4H8 (Isobutene)", 318, 4.927, 0.503, 0, 56.10632}, 
    {"SiClF3", 233.5, 4.715, 0.686, 0, 120.5334096}, {"SiCl2F2", 280.3, 4.984, 0.7329, 0, 136.9877064}, 
    {"SiCl3F", 333.8, 5.218, 0.49, 0, 153.4420032}, {"He", 3.96, 3.104, 0, 0.204956, 4.002602}, 
    {"Ne", 33.84, 2.804, 0, 0.3956, 20.1797}, {"Ar", 114.99, 3.402, 0, 1.6411, 39.948}, 
    {"Kr", 159.61, 3.628, 0, 2.4844, 83.8}, {"Xe", 220.83, 3.957, 0, 4.044, 131.29}, 
    {"F2", 109.86, 3.26, 0, 1.38, 37.9968}, {"Br2", 448.17, 4.055, 0, 7.02, 159.808}, 
    {"I2", 624.24, 4.333, 0, 10., 253.80894}, {"Cl2", 317.76, 4.012, 0, 4.61, 70.9054}, 
    {"O2", 117.83, 3.371, 0, 1.5812, 31.9988}, {"S", 1001.52, 4.361, 0, 2.9, 32.066}, 
    {"N2", 96.2, 3.615, 0, 1.7403, 28.0135}, {"H2", 25.13, 3.243, 0, 0.81, 2.01588}, 
    {"CS2", 420.73, 4.495, 0, 8.74, 76.1427}, {"CH4", 145.22, 3.732, 0, 2.593, 16.0425}, 
    {"C2H6 (ethane)", 232.77, 4.267, 0, 4.47, 30.069}, {"C3H8 (propane)", 281.88, 4.741, 0, 6.29, 44.0956}, 
    {"C2H4 (ethylene)", 215.2, 4.097, 0, 4.252, 28.0532}, {"C4H10 (butane)", 324.04, 5.115, 0, 8.2, 58.1222}, 
    {"BF3", 198.78, 3.923, 0, 3.31, 67.8052}, {"BCl3", 346.8, 5.006, 0, 9.38, 117.168}, 
    {"SiF4", 197.41, 4.444, 0, 5.45, 104.079}, {"SiH4", 205.56, 3.744, 0, 5.44, 32.1173}, 
    {"SiCl4", 387.27, 5.552, 0, 12., 169.896}, {"H2O", 192.814, 2.97509, 2.16312 + 68.2631/(temp + 13.1904), 
     0.207114 + 76.2066/(temp + 100.453), 18.0153}, {"CO2", 192.192 + 136.307*Exp[-0.00353196*temp], 
     3.81773 - 0.203782*Exp[-0.00101206*temp], 0, 2.65, 44.0095}, {"NH3", 200, 3.294, 1.849, 0, 17.0306}}; 
FEOSCG[p_, t_, sp_, x_, opts___] := Module[{p0, pa, lsp, \[CapitalDelta]x, erg, \[Rho], z, a, dax, sdax, f, modus, newsp}, 
    modus = Speed /. {opts} /. Options[FEOSCG]; newsp = NewSpecies /. {opts} /. Options[FEOSCG]; p0 = 0.1; 
     pa = ParaCG[t, sp, x, newsp]; lsp = Length[sp]; \[CapitalDelta]x = Table[x[[i]]/10000, {i, lsp}]; 
     \[CapitalDelta]x = DiagonalMatrix[\[CapitalDelta]x]; erg = PEOSCG[p, t, pa, x, Speed -> modus]; \[Rho] = erg[[1]][[1]]; 
     z = erg[[1]][[2]]; a = AEOSCGint[\[Rho], t, pa, x, Speed -> modus][[2]]/(r*t); 
     If[lsp == 1, Return[Exp[a + z - 1 - Log[z]]*(p/p0)]]; dax = Table[0, {i, lsp}]; 
     Do[dax[[i]] = (AEOSCGint[\[Rho], t, pa, x + \[CapitalDelta]x[[i]], Speed -> modus][[2]] - 
         AEOSCGint[\[Rho], t, pa, x - \[CapitalDelta]x[[i]], Speed -> modus][[2]])/(2*\[CapitalDelta]x[[i]][[i]]*r*t), {i, lsp}]; 
     sdax = Sum[x[[i]]*dax[[i]], {i, lsp}]; f = Table[Exp[a + dax[[i]] - sdax + z - 1 - Log[z]]*(p/p0), 
       {i, lsp}]]; 
AEOSCG[\[Rho]_, t_, sp_, x_, opts___] := Module[{pa, modus, newsp}, modus = Speed /. {opts} /. Options[AEOSCG]; 
     newsp = NewSpecies /. {opts} /. Options[AEOSCG]; pa = ParaCG[t, sp, x, newsp]; 
     AEOSCGint[\[Rho], t, pa, x, Speed -> modus]]; 
AEOSCGpara[\[Rho]_, t_, pa_, opts___] := Module[{palocal, modus, newsp}, 
    modus = Speed /. {opts} /. Options[AEOSCGpara]; newsp = NewSpecies /. {opts} /. Options[AEOSCGpara]; 
     palocal = pa; palocal[[1]] = {palocal[[1]]*k}; palocal[[2]] = {palocal[[2]]/10^10}; 
     palocal[[3]] = {palocal[[3]]^2/10^49}; palocal[[4]] = {palocal[[4]]/10^30}; 
     AEOSCGint[\[Rho], t, palocal, {1.}, Speed -> modus]]; 
GEOSCGpara[p_, t_, pa_, opts___] := Module[{palocal, erg, \[Rho], modus, newsp}, 
    modus = Speed /. {opts} /. Options[GEOSCGpara]; newsp = NewSpecies /. {opts} /. Options[GEOSCGpara]; 
     palocal = pa; palocal[[1]] = {palocal[[1]]*k}; palocal[[2]] = {palocal[[2]]/10^10}; 
     palocal[[3]] = {palocal[[3]]^2/10^49}; palocal[[4]] = {palocal[[4]]/10^30}; 
     erg = PEOSCG[p, t, palocal, {1.}, Speed -> modus]; \[Rho] = {erg[[1]][[1]], erg[[2]][[1]]}; 
     If[\[Rho][[2]] != 0, {{\[Rho][[1]], AEOSCGint[\[Rho][[1]], t, palocal, {1.}, Speed -> modus][[3]] + 
         p*(1/\[Rho][[1]])}, {\[Rho][[2]], AEOSCGint[\[Rho][[2]], t, palocal, {1.}, Speed -> modus][[3]] + 
         p*(1/\[Rho][[2]])}}, {{\[Rho][[1]], AEOSCGint[\[Rho][[1]], t, palocal, {1.}, Speed -> modus][[3]] + 
         p*(1/\[Rho][[1]])}, {0, 0}}]]; 
\[Rho]EOSCG[p_, t_, sp_, x_, opts___] := Module[{pa, erg, \[Rho], modus, newsp}, 
    modus = Speed /. {opts} /. Options[\[Rho]EOSCG]; newsp = NewSpecies /. {opts} /. Options[\[Rho]EOSCG]; 
     pa = ParaCG[t, sp, x, newsp]; erg = PEOSCG[p, t, pa, x, Speed -> modus]; 
     \[Rho] = {erg[[1]][[1]], erg[[2]][[1]]}]; 
GEOSCG[p_, t_, sp_, x_, opts___] := Module[{pa, erg, \[Rho], modus, newsp}, 
    modus = Speed /. {opts} /. Options[GEOSCG]; newsp = NewSpecies /. {opts} /. Options[GEOSCG]; 
     pa = ParaCG[t, sp, x, newsp]; erg = PEOSCG[p, t, pa, x, Speed -> modus]; If[erg == Null, Return[]]; 
     \[Rho] = {erg[[1]][[1]], erg[[2]][[1]]}; If[\[Rho][[2]] != 0, 
      {{\[Rho][[1]], AEOSCGint[\[Rho][[1]], t, pa, x, Speed -> modus][[3]] + p*(1/\[Rho][[1]])}, 
       {\[Rho][[2]], AEOSCGint[\[Rho][[2]], t, pa, x, Speed -> modus][[3]] + p*(1/\[Rho][[2]])}}, 
      {{\[Rho][[1]], AEOSCGint[\[Rho][[1]], t, pa, x, Speed -> modus][[3]] + p*(1/\[Rho][[1]])}, {0, 0}}]]; 
VEOSCG[p_, t_, sp_, x_, opts___] := Module[{pa, erg, v, modus, newsp}, 
    modus = Speed /. {opts} /. Options[VEOSCG]; newsp = NewSpecies /. {opts} /. Options[VEOSCG]; 
     pa = ParaCG[t, sp, x, newsp]; erg = PEOSCG[p, t, pa, x, Speed -> modus]; 
     If[erg[[2]] == {0, 0}, v = {1/erg[[1]][[1]], 0}, v = {1/erg[[1]][[1]], 1/erg[[2]][[1]]}]; v]; 
ParaCG[t_, sp_, x_, newsp_] := Module[{ptk, ptkex, i, pname, p\[Epsilon], p\[Sigma], p\[Mu], p\[Alpha], lsp, pos, \[Epsilon], \[Sigma], \[Mu], 
     \[Mu]2, \[Alpha], sx, pmw, mw}, ptk = parameter /. temp -> t; ptkex = newsp /. temp -> t; 
     ptk = Join[ptk, ptkex]; pname = Transpose[ptk][[1]]; p\[Epsilon] = Transpose[ptk][[2]]*k; 
     p\[Sigma] = Transpose[ptk][[3]]/10^10; p\[Mu] = Transpose[ptk][[4]]; p\[Alpha] = Transpose[ptk][[5]]/10^30; 
     pmw = Transpose[ptk][[6]]; lsp = Length[sp]; If[lsp == 0, Return["EOSCG error: no species selected"]]; 
     pos = Flatten[Table[Position[pname, sp[[i]]], {i, lsp}]]; If[lsp =!= Length[pos], 
      Return[{0., 0., 0., StringJoin["ParaCG error: ", ToString[lsp - Length[pos]], 
         " selected species not avaiable or error in text format"]}]]; 
     If[lsp =!= Length[x], Return[{0., 0., 0., StringJoin["ParaCG error: ", ToString[lsp - Length[x]], 
         " selected species does not have a corresponding composition"]}]]; sx = Sum[x[[i]], {i, lsp}]; 
     If[sx < 0.9999 || sx > 1.0001, Return[{0., 0., 0., StringJoin[
         "ParaCG error: sum of all molefractions is unequal to 1 (", ToString[sx], ")"]}]]; 
     \[Epsilon] = Table[p\[Epsilon][[pos[[i]]]], {i, lsp}]; \[Sigma] = Table[p\[Sigma][[pos[[i]]]], {i, lsp}]; 
     \[Mu] = Table[p\[Mu][[pos[[i]]]], {i, lsp}]; \[Mu]2 = \[Mu]^2/10^49; \[Alpha] = Table[p\[Alpha][[pos[[i]]]], {i, lsp}]; 
     mw = Table[pmw[[pos[[i]]]], {i, lsp}]; {\[Epsilon], \[Sigma], \[Mu]2, \[Alpha], mw}]; 
PEOSCG[p_, t_, pa_, x_, opts___] := Module[{i, j, f, f\.b4, f\.b4\.b4, f1\.b4, f2\.b4, g, \[Rho]0, \[Rho]1, \[Rho]2, \[Rho]a, \[Rho]p, 
     \[Rho]max, \[Delta], \[Rho], d\[Rho], \[CapitalDelta]\[Rho], maxi, tu, erg, m, facm, debug, debugt, debugp1, debugp2, modus, newsp}, 
    modus = Speed /. {opts} /. Options[PEOSCG]; newsp = NewSpecies /. {opts} /. Options[PEOSCG]; 
     If[debugt, tu = TimeUsed[]]; debug = False; debugt = False; debugp1 = False; debugp2 = False; maxi = 500; 
     \[Delta] = 1/1000.; \[Rho]0 = p/(r*t)/10; m = Plus @@ (x*pa[[5]]); \[CapitalDelta]\[Rho][\[Rho]_] := \[Rho]*\[Delta]; 
     f[\[Rho]_] := \[Rho]^2*((AEOSCGint[\[Rho] + \[CapitalDelta]\[Rho][\[Rho]], t, pa, x, Speed -> modus][[3]] - 
          AEOSCGint[\[Rho] - \[CapitalDelta]\[Rho][\[Rho]], t, pa, x, Speed -> modus][[3]])/(2*\[CapitalDelta]\[Rho][\[Rho]])) - p; 
     f\.b4[\[Rho]_] := (f[\[Rho] + \[CapitalDelta]\[Rho][\[Rho]]] - f[\[Rho] - \[CapitalDelta]\[Rho][\[Rho]]])/(2*\[CapitalDelta]\[Rho][\[Rho]]); 
     f\.b4\.b4[\[Rho]_] := (f\.b4[\[Rho] + \[CapitalDelta]\[Rho][\[Rho]]] - f\.b4[\[Rho] - \[CapitalDelta]\[Rho][\[Rho]]])/(2*\[CapitalDelta]\[Rho][\[Rho]]); 
     If[m > 6, facm = 2, facm = 10]; Do[\[Rho]p = f[\[Rho]\[Rho]]; If[\[Rho]p < p/10, Null, \[Rho]max = \[Rho]\[Rho]; Break[]], 
      {\[Rho]\[Rho], 1/m/facm, 0.1, 1/m/20}]; If[debugp1, plot1 = Plot[f[\[Rho]], {\[Rho], 1.*^-6, 0.1}, 
        PlotRange -> {-1, 1}]]; If[debugp2, plot2 = Plot[f\.b4[\[Rho]], {\[Rho], 1.*^-6, 0.1}]]; 
     If[debugp2, plot2 = Plot[f\.b4\.b4[\[Rho]], {\[Rho], 1.*^-6, 0.1}]]; If[debug, Print["L"]]; j = 0; i = 0; 
     \[Rho]a = \[Rho]max; f1\.b4 = f\.b4[\[Rho]a]; d\[Rho] = -f[\[Rho]a]/f1\.b4/100; \[Rho] = \[Rho]a + d\[Rho]; \[Rho]a = \[Rho]; 
     While[Abs[d\[Rho]/\[Rho]] > 10^(-5), j = j + 1; f2\.b4 = f\.b4[\[Rho]a]; If[f1\.b4*f2\.b4 < 0, 
        If[debug, Print["extremum, no solution from this side"]]; \[Rho] = 0; Break[]]; d\[Rho] = -f[\[Rho]a]/f2\.b4/2; 
       \[Rho] = \[Rho]a + d\[Rho]; If[\[Rho] < 0, \[Rho] = p/(r*t)/10; i = i + 1]; \[Rho]a = \[Rho]; f1\.b4 = f2\.b4; 
       If[debug, Print[{d\[Rho], \[Rho]}]]; If[\[Rho] > \[Rho]max, 
        If[debug, Print["error: molar density seems to be larger than ", \[Rho]max]]; \[Rho] = 0; Break[]]; 
       If[j > maxi, If[debug, Print["error: no convergence for liquid"]]; Break[]]; 
       If[i > 3, If[debug, Print["molar density negativ, no solution from this side"]]; \[Rho] = 0; Break[]]; ]; 
     If[\[Rho] > \[Rho]max, If[debug, Print["error: molar density seems to be larger than ", \[Rho]max]]; \[Rho] = 0]; 
     \[Rho]1 = \[Rho]; If[debug, Print["V"]]; j = 0; i = 0; \[Rho]a = \[Rho]0; f1\.b4 = f\.b4[\[Rho]a]; d\[Rho] = -f[\[Rho]a]/f1\.b4/100; 
     \[Rho] = \[Rho]a + d\[Rho]; \[Rho]a = \[Rho]; If[\[Rho]a < 0., \[Rho]a = \[Rho]0/100.]; While[Abs[d\[Rho]/\[Rho]] > 10^(-5), 
      j = j + 1; f2\.b4 = f\.b4[\[Rho]a]; If[f1\.b4*f2\.b4 < 0, If[debug, Print["extremum, no solution from this side"]]; 
         \[Rho] = 0; Break[]]; d\[Rho] = -f[\[Rho]a]/f2\.b4/2; \[Rho] = \[Rho]a + d\[Rho]; 
       If[\[Rho] < 0, \[Rho] = p/(r*t)/10; i = i + 1]; \[Rho]a = \[Rho]; If[debug, Print[{d\[Rho], \[Rho]}]]; f1\.b4 = f2\.b4; 
       If[\[Rho] > \[Rho]max, If[debug, Print["error: molar density seems to be larger than ", \[Rho]max]]; \[Rho] = 0; 
         Break[]]; If[j > maxi, If[debug, Print["error: no convergence for vapor"]]; Break[]]; 
       If[i > 3, If[debug, Print["molar density negativ, no solution from this side"]]; \[Rho] = 0; Break[]]; ]; 
     If[\[Rho] > \[Rho]max, If[debug, Print["error: molar density seems to be larger than ", \[Rho]max]]; \[Rho] = 0]; 
     \[Rho]2 = \[Rho]; If[\[Rho]1 == 0 && \[Rho]2 == 0, Print["fatal error: no solution detected"]; Return[]]; 
     If[\[Rho]1 == 0, \[Rho]1 = \[Rho]2; \[Rho]2 = 0]; If[Abs[\[Rho]1 - \[Rho]2] < \[Rho]1/1000., \[Rho]2 = 0.]; 
     If[\[Rho]2 > 0., erg = {{\[Rho]1, p/(\[Rho]1*r*t)}, {\[Rho]2, p/(\[Rho]2*r*t)}}, 
      erg = {{\[Rho]1, p/(\[Rho]1*r*t)}, {0., 0.}}]; If[\[Rho]2 > 0., 
      g = {AEOSCGint[erg[[1]][[1]], t, pa, x, Speed -> modus][[3]] + p/erg[[1]][[1]], 
         AEOSCGint[erg[[2]][[1]], t, pa, x, Speed -> modus][[3]] + p/erg[[2]][[1]]}; 
       If[debug, If[g[[1]] < g[[2]], Print["stable g: ", g[[1]]], Print["stable g: ", g[[2]]]]]; 
       If[debug, If[g[[1]] < g[[2]], Print["stable \[Rho],z: ", erg[[1]]], Print["stable \[Rho],z: ", erg[[2]]]]]; 
       If[g[[1]] < g[[2]], erg = {erg[[1]], erg[[2]]}, erg = {erg[[2]], erg[[1]]}], 
      If[debug, Print["stable g: ", AEOSCGint[erg[[1]][[1]], t, pa, x, Speed -> modus][[3]] + 
          p/erg[[1]][[1]]]]; If[debug, Print["stable \[Rho],z: ", erg[[1]]]]]; If[debug, Print[erg]]; 
     If[debugt, Print["timing : ", TimeUsed[] - tu]]; erg]; 
AEOSCGint[\[Rho]_, t_, pa_, x_, opts___] := Module[{a, modus, newsp}, 
    modus = Speed /. {opts} /. Options[AEOSCGint]; newsp = NewSpecies /. {opts} /. Options[AEOSCGint]; 
     If[modus == "slow", a = AEOSCGslow[\[Rho], t, pa, x], a = AEOSCGfast[\[Rho], t, pa[[1]], pa[[2]], pa[[3]], 
        pa[[4]], x]]; a]; 
AEOSCGslow[\[Rho]_, t_, pa_, x_] := Module[{i, j, m, lsp, \[Epsilon], \[Sigma], \[Mu], \[Mu]2, \[Alpha], \[Epsilon]ij, \[Sigma]ij, \[Sigma]3mix, 
     \[Epsilon]mix, sx, \[Beta], \[Rho]\.b4, \[Rho]SI, \[Rho]ij\.b4, \[Beta]ij\.b4, A0, A1, A2, A3, Ares, Aideal}, 
    \[Rho]SI = 10^6*\[Rho]; lsp = Length[x]; \[Epsilon] = pa[[1]]; \[Sigma] = pa[[2]]; \[Mu]2 = pa[[3]]; \[Alpha] = pa[[4]]; 
     \[Sigma]ij = Table[(\[Sigma][[i]] + \[Sigma][[j]])/2, {i, lsp}, {j, lsp}]; 
     \[Epsilon]ij = Table[Sqrt[\[Epsilon][[i]]*\[Epsilon][[j]]], {i, lsp}, {j, lsp}]; 
     \[Sigma]3mix = Sum[x[[i]]*x[[j]]*\[Sigma]ij[[i]][[j]]^3, {i, lsp}, {j, lsp}]; 
     \[Epsilon]mix = (1/\[Sigma]3mix)*Sum[x[[i]]*x[[j]]*\[Epsilon]ij[[i]][[j]]*\[Sigma]ij[[i]][[j]]^3, {i, lsp}, {j, lsp}]; 
     \[Beta] = \[Epsilon]mix/(k*t); \[Rho]\.b4 = \[Rho]SI*na*\[Sigma]3mix; \[Beta]ij\.b4 = \[Epsilon]ij/(k*t); \[Rho]ij\.b4 = \[Rho]SI*na*\[Sigma]ij^3; 
     A0 = r*t*ALJ[\[Beta], \[Rho]\.b4]; A1 = -2*Pi*na^2*\[Rho]SI*
       Sum[(x[[i]]*x[[j]]*(\[Alpha][[j]]*\[Mu]2[[i]] + \[Alpha][[i]]*\[Mu]2[[j]])*Jij[\[Beta]ij\.b4[[i]][[j]], \[Rho]ij\.b4[[i]][[j]]])/
         \[Sigma]ij[[i]][[j]]^3, {i, 1, lsp}, {j, 1, lsp}]; 
     A2 = -(2*Pi*na^2*\[Rho]SI*Sum[(x[[i]]*x[[j]]*\[Mu]2[[i]]*\[Mu]2[[j]]*Jij[\[Beta]ij\.b4[[i]][[j]], \[Rho]ij\.b4[[i]][[j]]])/
           \[Sigma]ij[[i]][[j]]^3, {i, 1, lsp}, {j, 1, lsp}])/(3*k*t); 
     A3 = (32*Pi^3*na^3*\[Rho]SI^2*Sqrt[(14*Pi)/5]*Sum[(x[[i]]*x[[j]]*x[[m]]*\[Mu]2[[i]]*\[Mu]2[[j]]*\[Mu]2[[m]]*
           Kijm[i, j, m, \[Beta]ij\.b4, \[Rho]ij\.b4])/(\[Sigma]ij[[i]][[j]]*\[Sigma]ij[[i]][[m]]*\[Sigma]ij[[j]][[m]]), {i, 1, lsp}, 
         {j, 1, lsp}, {m, 1, lsp}])/(135*(k*t)^2); If[A2 != 0, Ares = A0 + A1 + A2/(1 - A3/A2), 
      Ares = A0 + A1]; Aideal = (-(r*t))*Sum[x[[i]]*Log[0.1/(x[[i]]*\[Rho]*r*t)], {i, 1, lsp}]; 
     {Aideal, Ares, Aideal + Ares}]; 
ALJ[\[Beta]_, \[Rho]\.b4_] := Module[{P1, P2, P3, P4, P5, P6, P7, P8, P9, P10, C1, C2, A1, A2, A3, A4, A5, A6, B1, B2, 
     B3, B4, B5, B6, A00, A01, A10, A11, A12, A21, A22, A23, A31, A32, A33, A34, \[Eta], d, \[Sigma]0, \[Sigma]1, dB, \[Delta], 
     eq, erg, \[Eta]w, f1, f2, I12, I6, dw, rm, \[Xi], a0, a1, a2, a3, I2, ARPA, AHTA, AHS}, 
    P1 = 1.186892378996; P2 = -0.4721963005527; P3 = 3.259515855283; P4 = 3.055229342609; P5 = 1.095409321023; 
     P6 = 1.282306659774/10^2; P7 = 9.55712461425/10^2; P8 = 13.67807693107; P9 = 35.75464856619; 
     P10 = 16.04724381643; C1 = {1.2011, 0.06489, -76.86, 562.686, -2280.09, 6266.84, -11753.4, 14053.8, 
       -9491.49, 2731.03}; C2 = {0.58889, -7.45536, 40.5759, -104.897, 60.2547, 390.631, -1193.08, 1576.35, 
       -1045.91, 283.758}; A1 = -0.120078459237; A2 = -0.808712488307; A3 = 0.321543801337; 
     A4 = 1.16965477132; A5 = -0.410564939543; A6 = -0.516834310691; B1 = -2.18839961483; B2 = 1.59897428009; 
     B3 = -0.392578806128; B4 = -0.189396607904; B5 = -0.576898496254; B6 = -0.0185167641359; 
     A00 = 0.9985937977069455; A01 = 0.5079834224407451; A10 = 1.021887697885469; A11 = -5.136619463333883; 
     A12 = -5.196188074016755; A21 = -6.049240839050804; A22 = 18.67848155616692; A23 = 20.10652684217768; 
     A31 = 9.896491419756988; A32 = 14.6738380473899; A33 = -77.44825116542995; A34 = -4.82871082941229; 
     \[Eta] = (1/6)*Pi*d^3*\[Rho]\.b4; \[Sigma]0 = (1 - \[Eta]/2)/(1 - \[Eta])^3; 
     \[Sigma]1 = (-1.51*\[Eta]^4 - 5.7865*\[Eta]^3 + \[Eta]^2/2 - (15*\[Eta])/2 + 2)/(1 - \[Eta])^4; 
     dB = (P1*\[Beta]^(1/12) + P2*\[Beta]^(7/12) + P5*\[Beta]^3 + P4*\[Beta]^2 + P3*\[Beta])/(\[Beta] + 1)^3; 
     \[Delta] = (P6 + P7*\[Beta]^(1/2))/(1 + P8*\[Beta]^(1/2) + P10*\[Beta]^(3/2) + P9*\[Beta]); 
     eq = N[dB*((\[Delta]*\[Sigma]1)/(2*\[Sigma]0) + 1.) - d == 0.]; erg = FindRoot[eq, {d, dB}, MaxIterations -> 1000]; 
     d = d /. erg; \[Eta]w = \[Eta] - \[Eta]^2/16; f1 = Sum[C1[[i]]*\[Eta]w^i, {i, 1, 10}]; 
     f2 = Sum[C2[[i]]*\[Eta]w^(i + 1), {i, 1, 10}]; ARPA = (192*\[Beta]^3*f2)/Pi - (12*\[Beta]^2*f1)/Pi; 
     I12 = (B6*\[Eta]w^3 + B5*\[Eta]w^2 + B4*\[Eta]w + 1)/(9*(B3*\[Eta]w^3 + B2*\[Eta]w^2 + B1*\[Eta]w + 1)); 
     I6 = (A6*\[Eta]w^3 + A5*\[Eta]w^2 + A4*\[Eta]w + 1)/(3*(A3*\[Eta]w^3 + A2*\[Eta]w^2 + A1*\[Eta]w + 1)); 
     dw = d*(1 - \[Eta]/16)^(1/3); rm = 2^(1/6); \[Xi] = rm/dw; a0 = (A00 + A01*\[Eta]w)/(1 - \[Eta]w)^2; 
     a1 = (A12*\[Eta]w^2 + A11*\[Eta]w + A10)/(1 - \[Eta]w)^3; a2 = (A23*\[Eta]w^3 + A22*\[Eta]w^2 + A21*\[Eta]w)/(1 - \[Eta]w)^4; 
     a3 = (A34*\[Eta]w^4 + A33*\[Eta]w^3 + A32*\[Eta]w^2 + A31*\[Eta]w)/(1 - \[Eta]w)^5; 
     I2 = (-(1/35))*3*a3*\[Xi]^5 - (9/64)*(a2 - a3)*\[Xi]^4 - (2/9)*(a1 - a2 + a3/2)*\[Xi]^3 - 
       (9/40)*(a0 - a1 + a2/2 - a3/6)*\[Xi]^2 + (1/8)*(a0 - a1/3 + a2/12 - a3/60) + 
       (a0/4 + a1/12 + a2/24 + a3/24)/dw^6 - (a0/10 + a1/90 + a2/720 + a3/5040)/dw^12; 
     AHTA = 48*\[Beta]*\[Eta]w*(I12/dw^12 + I2 - I6/dw^6); AHS = (4*\[Eta] - 3*\[Eta]^2)/(1 - \[Eta])^2; AHS + AHTA + ARPA]; 
ULJ[\[Beta]\.b4_, \[Rho]\.b4_] := Module[{\[CapitalDelta]\[Beta]\.b4}, \[CapitalDelta]\[Beta]\.b4 = \[Beta]\.b4/10^6; 
     (ALJ[\[Beta]\.b4 + \[CapitalDelta]\[Beta]\.b4, \[Rho]\.b4] - ALJ[\[Beta]\.b4 - \[CapitalDelta]\[Beta]\.b4, \[Rho]\.b4])/(2*\[CapitalDelta]\[Beta]\.b4)]; 
ZLJ[\[Beta]\.b4_, \[Rho]\.b4_] := Module[{\[CapitalDelta]\[Rho]\.b4}, \[CapitalDelta]\[Rho]\.b4 = \[Rho]\.b4/10^6; 
     1 + \[Rho]\.b4*((ALJ[\[Beta]\.b4, \[Rho]\.b4 + \[CapitalDelta]\[Rho]\.b4] - ALJ[\[Beta]\.b4, \[Rho]\.b4 - \[CapitalDelta]\[Rho]\.b4])/(2*\[CapitalDelta]\[Rho]\.b4))]; 
Jij[\[Beta]\.b4_, \[Rho]\.b4_] := -((4*\[Beta]\.b4*ULJ[\[Beta]\.b4, \[Rho]\.b4] - ZLJ[\[Beta]\.b4, \[Rho]\.b4] + 1)/(16*Pi*\[Rho]\.b4*\[Beta]\.b4)); 
K\.b4[\[Beta]\.b4_, \[Rho]\.b4_] := Module[{M1, M2, M3, M4, M5, M6}, M1 = -1.050534; M2 = 1.747476; M3 = 1.749366; 
     M4 = -1.999227; M5 = -0.661046; M6 = -3.02872; Exp[(-M1)*Log[\[Beta]\.b4]*\[Rho]\.b4^2 + M2*\[Rho]\.b4^2 - 
       M3*Log[\[Beta]\.b4]*\[Rho]\.b4 + M4*\[Rho]\.b4 - M5*Log[\[Beta]\.b4] + M6]]; 
Kijm[i_, j_, m_, \[Beta]ij\.b4_, \[Rho]ij\.b4_] := (K\.b4[\[Beta]ij\.b4[[i]][[j]], \[Rho]ij\.b4[[i]][[j]]]*
     K\.b4[\[Beta]ij\.b4[[i]][[m]], \[Rho]ij\.b4[[i]][[m]]]*K\.b4[\[Beta]ij\.b4[[j]][[m]], \[Rho]ij\.b4[[j]][[m]]])^(1/3); 
flist[p_, t_, species_, from_, to_, nincr_, opts___] := 
   Module[{cc, erg, i, x, compl, f, incr, debug, modus, newsp}, modus = Speed /. {opts} /. Options[flist]; 
     newsp = NewSpecies /. {opts} /. Options[flist]; debug = False; incr = (to - from)/nincr; 
     cc = Table[i, {i, from, to, incr}]; erg = Table[0, {i, Length[cc]}]; 
     Do[x = cc[[i]]; compl = {x, 1 - x}; f = FEOSCG[p, t, species, compl, Speed -> modus]; f = f*compl; 
       If[debug, Print[{p, t, x, f}]]; erg[[i]] = {{x, f[[1]]}, {x, f[[2]]}}, {i, 1, Length[cc]}]; erg]; 
miscgap[p_, t_, species_, increments_:25, opts___] := Module[{debug, erg, f1data, f2data, f1, f2, x, xl, xg, 
     compl, compg, fl, fg, modus, newsp}, modus = Speed /. {opts} /. Options[miscgap]; 
     newsp = NewSpecies /. {opts} /. Options[miscgap]; debug = False; 
     erg = flist[p, t, species, 1/10.^10, 1. - 1/10^10, increments]; f1data = Transpose[erg][[1]]; 
     f2data = Transpose[erg][[2]]; If[debug, ListPlot[f1data]]; If[debug, ListPlot[f2data]]; 
     f1 = Interpolation[f1data]; f2 = Interpolation[f2data]; 
     x = FindRoot[{f1[xl] == f1[xg], f2[xl] == f2[xg]}, {xl, 0.99}, {xg, 0.01}, MaxIterations -> 1000]; 
     xl = xl /. x; xg = xg /. x; compl = {xl, 1 - xl}; compg = {xg, 1 - xg}; 
     fl = FEOSCG[p, t, species, compl, Speed -> modus]*compl; 
     fg = FEOSCG[p, t, species, compg, Speed -> modus]*compg; 
     If[debug, Print[TableForm[{{"P [MPa]", "T [K]", "T [\[Degree]C]"}, {p, t, t - 273.15}, {}, 
          {"", "x_l", "x_g", "f_l", "f_g", "ln f_l", "ln f_g", "RT ln f_l", "RT ln f_g", "\[CapitalDelta]G"}, 
          {species[[1]], xl, xg, fl[[1]], fg[[1]], Log[fl[[1]]], Log[fg[[1]]], r*t*Log[fl[[1]]], 
           r*t*Log[fg[[1]]], r*t*Log[fl[[1]]] - r*t*Log[fg[[1]]]}, {species[[2]], 1 - xl, 1 - xg, fl[[2]], 
           fg[[2]], Log[fl[[2]]], Log[fg[[2]]], r*t*Log[fl[[2]]], r*t*Log[fg[[2]]], 
           r*t*Log[fl[[2]]] - r*t*Log[fg[[2]]]}}]]; ]; 
     {{xl, fl[[1]], fg[[1]], r*t*(Log[fl[[1]]] - Log[fg[[1]]])}, {xg, fl[[2]], fg[[2]], 
       r*t*(Log[fl[[2]]] - Log[fg[[2]]])}}]; 
miscgapNewton[p_, t_, species_, xx_:0.9999, yy_:0.0001, opts___] := 
   Module[{debug, h, k, x, y, delta, xp, xm, yp, ym, fug, fl, flp, flm, gl, glp, glm, fg, fgp, fgm, gg, ggp, 
     ggm, f, g, fx, fy, gx, gy, modus, newsp}, modus = Speed /. {opts} /. Options[miscgapNewton]; 
     newsp = NewSpecies /. {opts} /. Options[miscgapNewton]; debug = False; k = 1; h = 1; j = 0; x = xx; 
     y = yy; While[Abs[k] > 0.0005 || Abs[h] > 0.0005, delta = 0.0001; xp = x + delta; xm = x - delta; 
       yp = x + delta; ym = x - delta; fug = FEOSCG[p, t, species, {x, 1 - x}, Speed -> modus]*{x, 1 - x}; 
       fl = fug[[1]]; gl = fug[[2]]; fug = FEOSCG[p, t, species, {y, 1 - y}, Speed -> modus]*{y, 1 - y}; 
       fg = fug[[1]]; gg = fug[[2]]; fug = FEOSCG[p, t, species, {x + delta, 1 - (x + delta)}, Speed -> modus]*
         {x + delta, 1 - (x + delta)}; flp = fug[[1]]; glp = fug[[2]]; 
       fug = FEOSCG[p, t, species, {y + delta, 1 - (y + delta)}, Speed -> modus]*{y + delta, 1 - (y + delta)}; 
       fgp = fug[[1]]; ggp = fug[[2]]; fug = FEOSCG[p, t, species, {x - delta, 1 - (x - delta)}, 
          Speed -> modus]*{x - delta, 1 - (x - delta)}; flm = fug[[1]]; glm = fug[[2]]; 
       fug = FEOSCG[p, t, species, {y - delta, 1 - (y - delta)}, Speed -> modus]*{y - delta, 1 - (y - delta)}; 
       fgm = fug[[1]]; ggm = fug[[2]]; f = fl - fg; g = gl - gg; fx = (flp - flm)/(2*delta); 
       fy = -(fgp - fgm)/(2*delta); gx = (glp - glm)/(2*delta); gy = -(ggp - ggm)/(2*delta); 
       k = (g*fx - f*gx)/(fy*gx - gy*fx); h = -(f + k*fy)/fx; If[Abs[h] > 0.05 || Abs[k] > 0.05, 
        x = x + h/5; y = y + k/5, x = x + h; y = y + k]; 
       If[debug, Print[TableForm[{{"P [MPa]", "T [K]", "T [\[Degree]C]"}, {p, t, t - 273.15}, {}, 
           {"", "x_l", "x_g", "f_l", "f_g", "ln f_l", "ln f_g", "RT ln f_l", "RT ln f_g", "\[CapitalDelta]G"}, 
           {species[[1]], x, y, fl, fg, Log[fl], Log[fg], r*t*Log[fl], r*t*Log[fg], r*t*Log[fl/fg]}, 
           {species[[2]], 1 - x, 1 - y, gl, gg, Log[gl], Log[gg], r*t*Log[gl], r*t*Log[gg], 
            r*t*Log[gl/gg]}}]]]; ]; fl = FEOSCG[p, t, species, {x, 1 - x}, Speed -> modus]*{x, 1 - x}; 
     fg = FEOSCG[p, t, species, {y, 1 - y}, Speed -> modus]*{y, 1 - y}; 
     If[debug, Print[TableForm[{{"P [MPa]", "T [K]", "T [\[Degree]C]"}, {p, t, t - 273.15}, {}, 
         {"", "x_l", "x_g", "f_l", "f_g", "ln f_l", "ln f_g", "RT ln f_l", "RT ln f_g", "\[CapitalDelta]G"}, 
         {species[[1]], x, y, fl[[1]], fg[[1]], Log[fl[[1]]], Log[fg[[1]]], r*t*Log[fl[[1]]], 
          r*t*Log[fg[[1]]], r*t*Log[fl[[1]]/fg[[1]]]}, {species[[2]], 1 - x, 1 - y, fl[[2]], fg[[2]], 
          Log[fl[[2]]], Log[fg[[2]]], r*t*Log[fl[[2]]], r*t*Log[fg[[2]]], r*t*Log[fl[[2]]/fg[[2]]]}}]]]; 
     {{x, fl[[1]], fg[[1]], r*t*(Log[fl[[1]]] - Log[fg[[1]]])}, {y, fl[[2]], fg[[2]], 
       r*t*(Log[fl[[2]]] - Log[fg[[2]]])}}]; 
End[]
EndPackage[]



























